"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const cardinal = __importStar(require("cardinal"));
const _ = __importStar(require("lodash"));
const chalk_1 = __importDefault(require("chalk"));
const getLineWithContext = function (lines, lineNumber, context) {
    // Lines start at 1, arrays at 0
    const line = lineNumber - 1;
    const firstLine = line > context ? line - context : 0;
    const lastLine = line + context < lines.length ? line + context : lines.length;
    return {
        before: lines.slice(firstLine, line),
        line: lines[line],
        after: lines.slice(line + 1, lastLine + 1)
    };
};
const renderStepsErrors = function (errors) {
    const errorsByFile = _.groupBy(errors, (error) => {
        const intent = error.details.intent;
        return intent.toRaw().meta.callsite.file;
    });
    const messages = [];
    for (const file of Object.keys(errorsByFile)) {
        const fileContents = fs.readFileSync(file, 'utf-8');
        const highlightedCode = cardinal.highlight(fileContents, { linenos: true });
        const lines = highlightedCode.split('\n');
        const fileErrorsMessage = (0, chalk_1.default) `{red Errors in ${file}}\n\n`;
        const errorMessages = errorsByFile[file]
            .map((error) => {
            const intent = error.details.intent;
            const callsite = intent.toRaw().meta.callsite;
            const context = 2;
            const { before, line, after } = getLineWithContext(lines, callsite.line, context);
            const beforeLines = before.map((line) => (0, chalk_1.default) `${line}\n`).join('');
            const afterLines = after.map((line) => (0, chalk_1.default) `${line}\n`).join('');
            const highlightedLine = (0, chalk_1.default) `{bold ${line}}\n`;
            const formattedCode = beforeLines + highlightedLine + afterLines;
            return (0, chalk_1.default) `{red Line ${String(callsite.line)}:} {bold ${error.message}}\n${formattedCode}`;
        })
            .join('\n');
        messages.push(`${fileErrorsMessage}${errorMessages}`);
    }
    console.error((0, chalk_1.default) `{red.bold Validation failed}\n\n`);
    console.error(messages.join('\n'));
    console.error((0, chalk_1.default) `🚨  {bold.red Migration unsuccessful}`);
};
exports.default = renderStepsErrors;
//# sourceMappingURL=steps-errors.js.map