"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditorLayoutDeleteFieldGroupAction = void 0;
const action_1 = require("../action");
class EditorLayoutDeleteFieldGroupAction extends action_1.EntityAction {
    constructor(contentTypeId, fieldGroupId) {
        super();
        this.contentTypeId = contentTypeId;
        this.fieldGroupId = fieldGroupId;
    }
    getEntityType() {
        return action_1.EntityType.EditorInterface;
    }
    getEntityId() {
        return this.contentTypeId;
    }
    async applyTo(editorInterfaces) {
        await editorInterfaces.deleteEditorLayoutFieldGroup(this.fieldGroupId);
        await editorInterfaces.deleteGroupControl(this.fieldGroupId);
    }
}
exports.EditorLayoutDeleteFieldGroupAction = EditorLayoutDeleteFieldGroupAction;
//# sourceMappingURL=editor-layout-delete-field-group.js.map