"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createEditorLayoutSchema = void 0;
const Joi = __importStar(require("joi"));
const editor_layout_1 = require("../../../utils/editor-layout");
const fieldSchema = Joi.object().keys({
    fieldId: Joi.string().required()
});
function createEditorLayoutSchema(tabsIds) {
    const fieldSetSchema = Joi.object().keys({
        name: Joi.string().required(),
        groupId: Joi.string().required().invalid(...tabsIds),
        items: Joi.array().items(fieldSchema)
    });
    const editorLayoutSchema = Joi.array().items(Joi.object().keys({
        name: Joi.string().required(),
        groupId: Joi.string().required().valid(...tabsIds),
        items: Joi.array()
            .items(Joi.alternatives().conditional(Joi.object({ groupId: Joi.exist() }).unknown(), {
            then: fieldSetSchema,
            otherwise: fieldSchema
        }))
    })).max(editor_layout_1.MAX_TABS);
    return editorLayoutSchema;
}
exports.createEditorLayoutSchema = createEditorLayoutSchema;
//# sourceMappingURL=editor-layout-schema.js.map